## rocm-llvm 6.4.3+dfsg

=== amd/comgr/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

include(CheckIncludeFileCXX)

file(READ "VERSION.txt" comgr_ver_file)

string(REGEX MATCH "#COMGR_VERSION_MAJOR\n([0-9]*)" _ ${comgr_ver_file})
set (ver_major ${CMAKE_MATCH_1})
string(REGEX MATCH "#COMGR_VERSION_MINOR\n([0-9]*)" _ ${comgr_ver_file})
set (ver_minor ${CMAKE_MATCH_1})

message("Comgr Version: ${ver_major}.${ver_minor}.0")

project(amd_comgr VERSION "${ver_major}.${ver_minor}.0" LANGUAGES C CXX)
set(amd_comgr_NAME "${PROJECT_NAME}")

# Get git branch and commit hash to add to log for easier debugging.
# Modeled after https://github.com/pmirshad/cmake-with-git-metadata.
# Current working branch
if(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")
execute_process(
  COMMAND git rev-parse --abbrev-ref HEAD
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE AMD_COMGR_GIT_BRANCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
# Shortened commit hash
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE AMD_COMGR_GIT_COMMIT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
else(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")
  set(AMD_COMGR_GIT_BRANCH "not-available")
  set(AMD_COMGR_GIT_COMMIT "not-available")
endif(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
option(FILE_REORG_BACKWARD_COMPATIBILITY "Enable File Reorg with backward compatibility" OFF)
# Optionally, build Compiler Support with ccache.
set(ROCM_CCACHE_BUILD OFF CACHE BOOL "Set to ON for a ccache enabled build")
if (ROCM_CCACHE_BUILD)
  find_program(CCACHE_PROGRAM ccache)
  if (CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_PROGRAM})
  else()
    message(WARNING "Unable to find ccache. Falling back to real compiler")
  endif() # if (CCACHE_PROGRAM)
endif() # if (ROCM_CCACHE_BUILD)

find_package(ROCM QUIET)
if (ROCM_FOUND)
  include(ROCMSetupVersion)
  rocm_setup_version(VERSION "${amd_comgr_VERSION}")
endif()

# BUILD_SHARED_LIBS is a frustratingly global variable common to all
# projects. LLVM also defines an option for the same varible with the
# opposite default, which will overwrite our default preference
# here. Ignore the regular BUILD_SHARED_LIBS in an embedded llvm
# build. Try to use BUILD_SHARED_LIBS to hint our project specific
# version in a standalone build.
set(build_shared_libs_default ON)
if(NOT DEFINED LLVM_SOURCE_DIR AND DEFINED BUILD_SHARED_LIBS)
  set(build_shared_libs_default ${BUILD_SHARED_LIBS})
endif()

option(COMGR_BUILD_SHARED_LIBS "Build the shared library"
       ${build_shared_libs_default})

set(SOURCES
  src/comgr-cache.cpp
  src/comgr-cache-command.cpp
  src/comgr-cache-bundler-command.cpp
  src/comgr-compiler.cpp
  src/comgr.cpp
  src/comgr-device-libs.cpp
  src/comgr-diagnostic-handler.cpp
  src/comgr-disassembly.cpp
  src/comgr-elfdump.cpp
  src/comgr-env.cpp
  src/comgr-metadata.cpp
  src/comgr-objdump.cpp
  src/comgr-signal.cpp
  src/comgr-spirv-command.cpp
  src/comgr-symbol.cpp
  src/comgr-symbolizer.cpp
  src/time-stat/time-stat.cpp)

if(COMGR_BUILD_SHARED_LIBS)
  add_library(amd_comgr SHARED ${SOURCES})
  # Windows doesn't have a strip utility, so CMAKE_STRIP won't be set.
  if((CMAKE_BUILD_TYPE STREQUAL "Release") AND NOT ("${CMAKE_STRIP}" STREQUAL ""))
    if (APPLE)
      # Building on Mac fails unless -x is passed to the strip command
      add_custom_command(TARGET amd_comgr POST_BUILD COMMAND ${CMAKE_STRIP} -x $<TARGET_FILE:amd_comgr>)
    else()
      add_custom_command(TARGET amd_comgr POST_BUILD COMMAND ${CMAKE_STRIP} $<TARGET_FILE:amd_comgr>)
    endif()
  endif()
else()
  add_library(amd_comgr STATIC ${SOURCES})
endif()

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  find_package(AMDDeviceLibs REQUIRED CONFIG)
  find_package(Clang REQUIRED CONFIG)
  find_package(LLD REQUIRED CONFIG)

  target_include_directories(amd_comgr
    PRIVATE
      ${LLVM_INCLUDE_DIRS}
      ${CLANG_INCLUDE_DIRS}
      ${LLD_INCLUDE_DIRS})
else()
  # If building with LLVM_EXTERNAL_PROJECTS, we've already picked up
  # the include directories for LLVM, but not clang.
  #
  if (LLVM_EXTERNAL_CLANG_SOURCE_DIR)
    target_include_directories(amd_comgr
      PRIVATE
        ${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/include
        ${LLVM_BINARY_DIR}/tools/clang/include)
  endif()

  if (LLVM_EXTERNAL_LLD_SOURCE_DIR)
    target_include_directories(amd_comgr
      PRIVATE
        ${LLVM_EXTERNAL_LLD_SOURCE_DIR}/include
        ${LLVM_BINARY_DIR}/tools/lld/include)
  endif()
endif()

target_include_directories(amd_comgr
  PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/src)

message("")
message("------------LLVM_DIR: ${LLVM_DIR}")
message("---LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")
message("---LLVM_LIBRARY_DIRS: ${LLVM_LIBRARY_DIRS}")
message("-----------Clang_DIR: ${Clang_DIR}")
message("--CLANG_INCLUDE_DIRS: ${CLANG_INCLUDE_DIRS}")
message("----LLD_INCLUDE_DIRS: ${LLD_INCLUDE_DIRS}")
message("---AMDDeviceLibs_DIR: ${AMDDeviceLibs_DIR}")
message("------------ROCM_DIR: ${ROCM_DIR}")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if (ADDRESS_SANITIZER)
  set(ASAN_LINKER_FLAGS "-fsanitize=address")
  set(ASAN_COMPILER_FLAGS "-fno-omit-frame-pointer -fsanitize=address")

  if (NOT CMAKE_COMPILER_IS_GNUCC)
    if (COMGR_BUILD_SHARED_LIBS)
      set(ASAN_LINKER_FLAGS "${ASAN_LINKER_FLAGS} -shared-libsan")
    else()
      set(ASAN_LINKER_FLAGS "${ASAN_LINKER_FLAGS} -static-libsan")
    endif()
  endif()

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ASAN_COMPILER_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ASAN_COMPILER_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ASAN_LINKER_FLAGS} -s")
  set(CMAKE_SHARED_LINKER_FLAGS
    "${CMAKE_SHARED_LINKER_FLAGS} ${ASAN_LINKER_FLAGS}")
endif()

set(AMD_COMGR_PRIVATE_COMPILE_OPTIONS)
set(AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS ${LLVM_DEFINITIONS})
set(AMD_COMGR_PUBLIC_LINKER_OPTIONS)
set(AMD_COMGR_PRIVATE_LINKER_OPTIONS)

list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "AMD_COMGR_GIT_COMMIT=${AMD_COMGR_GIT_COMMIT}")
list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "AMD_COMGR_GIT_BRANCH=${AMD_COMGR_GIT_BRANCH}")
message("----COMGR_GIT_COMMIT: ${AMD_COMGR_GIT_COMMIT}")
message("----COMGR_GIT_BRANCH: ${AMD_COMGR_GIT_BRANCH}")
message("")

option(COMGR_DISABLE_SPIRV "To disable SPIRV in Comgr" OFF)

if (NOT COMGR_DISABLE_SPIRV)
  # TODO: Explore switching this to CHECK_INCLUDE_FILE_CXX() macro
  if (NOT EXISTS "${LLVM_INCLUDE_DIRS}/LLVMSPIRVLib/LLVMSPIRVLib.h")
    message("-- LLVMSPIRVLib/LLVMSPIRVLib.h not found")
    set(COMGR_DISABLE_SPIRV ON)
  else()
    message("-- LLVMSPIRVLib/LLVMSPIRVLib.h found")
  endif()
endif()

if(${COMGR_DISABLE_SPIRV})
    list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "COMGR_DISABLE_SPIRV")
  message("-- Comgr SPIRV Disabled")
else()
  message("-- Comgr SPIRV Enabled")
endif()


if (UNIX)
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS
    -fno-rtti -Wall -Wno-attributes -fms-extensions -fvisibility=hidden)
  # TODO: Confirm this is actually needed due to LLVM/Clang code
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS -fno-strict-aliasing)
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS
    _GNU_SOURCE __STDC_LIMIT_MACROS __STDC_CONSTANT_MACROS AMD_COMGR_BUILD)
  list(APPEND AMD_COMGR_PUBLIC_LINKER_OPTIONS -pthread)
  if (NOT APPLE AND COMGR_BUILD_SHARED_LIBS)
    configure_file(
      src/exportmap.in
      src/exportmap @ONLY)
    list(APPEND AMD_COMGR_PRIVATE_LINKER_OPTIONS
      "-Wl,--version-script=${CMAKE_CURRENT_BINARY_DIR}/src/exportmap")
    # When building a shared library with -fsanitize=address we can't be
    # strict about undefined symbol references, as Clang won't include
    # libasan in the link, see
    # https://clang.llvm.org/docs/AddressSanitizer.html
    if (NOT ADDRESS_SANITIZER)
      list(APPEND AMD_COMGR_PRIVATE_LINKER_OPTIONS
        -Wl,--no-undefined)
    endif()
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS
    "/wd4244" #[[Suppress 'argument' : conversion from 'type1' to 'type2', possible loss of data]]
    "/wd4624" #[[Suppress 'derived class' : destructor could not be generated because a base class destructor is inaccessible]]
    "/wd4267" #[[Suppress 'var' : conversion from 'size_t' to 'type', possible loss of data]]
    "/wd4291" #[[Suppress 'declaration' : no matching operator delete found; memory will not be freed if initialization throws an exception]]
    "/wd4146" #[[Suppress 'unary minus operator applied to unsigned type, result still unsigned]])
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS _HAS_EXCEPTIONS=0)
endif()

# Windows is strict about visibility of exports in shared libraries, so we ask
# GCC/Clang to also be strict, and then explicitly mark each exported symbol in
# the shared header.
list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS AMD_COMGR_EXPORT)

include(bc2h)
include(opencl_pch)
include(DeviceLibs)

# Add major version to the name on windows, including Win64
if (WIN32)
  set_target_properties(amd_comgr PROPERTIES
    OUTPUT_NAME "amd_comgr_${amd_comgr_VERSION_MAJOR}")
endif()

set_target_properties(amd_comgr PROPERTIES
  CXX_STANDARD 17
  CXX_STANDARD_REQUIRED Yes
  CXX_EXTENSIONS No)
if (ROCM_FOUND)
  rocm_set_soversion(amd_comgr "${amd_comgr_VERSION_MAJOR}.${amd_comgr_VERSION_MINOR}")
else()
  set_target_properties(amd_comgr PROPERTIES
    SOVERSION "${amd_comgr_VERSION_MAJOR}"
    VERSION "${amd_comgr_VERSION_MAJOR}.${amd_comgr_VERSION_MINOR}.${amd_comgr_VERSION_PATCH}")
endif()

if (NOT COMGR_BUILD_SHARED_LIBS)
  set_target_properties(amd_comgr PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

# Overwrite the name on 32-bit Linux and Windows
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
  set_target_properties(amd_comgr PROPERTIES OUTPUT_NAME "amd_comgr32")
endif()

target_compile_options(amd_comgr
  PRIVATE "${AMD_COMGR_PRIVATE_COMPILE_OPTIONS}")
target_compile_definitions(amd_comgr
  PRIVATE "${AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS}")
target_include_directories(amd_comgr
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:include>)

configure_file(
  include/amd_comgr.h.in
  include/amd_comgr.h @ONLY)

set(AMD_COMGR_CONFIG_NAME amd_comgr-config.cmake)
set(AMD_COMGR_TARGETS_NAME amd_comgr-targets.cmake)
set(AMD_COMGR_VERSION_NAME amd_comgr-config-version.cmake)
set(AMD_COMGR_PACKAGE_PREFIX cmake/amd_comgr)

# Generate the build-tree package.
set(AMD_COMGR_PREFIX_CODE)
if (NOT COMGR_BUILD_SHARED_LIBS)
  string(APPEND AMD_COMGR_PREFIX_CODE "\ninclude(CMakeFindDependencyMacro)\n")
  string(APPEND AMD_COMGR_PREFIX_CODE "find_dependency(Clang REQUIRED)\n")
  string(APPEND AMD_COMGR_PREFIX_CODE "find_dependency(LLD REQUIRED)\n")
endif()

set(AMD_COMGR_TARGETS_PATH
  "${CMAKE_CURRENT_BINARY_DIR}/lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_TARGETS_NAME}")
set(AMD_COMGR_VERSION_PATH
  "${CMAKE_CURRENT_BINARY_DIR}/lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_VERSION_NAME}")
export(TARGETS amd_comgr
  FILE "lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_TARGETS_NAME}")
configure_file("cmake/${AMD_COMGR_CONFIG_NAME}.in"
  "lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_CONFIG_NAME}"
  @ONLY)
write_basic_package_version_file("${AMD_COMGR_VERSION_PATH}"
  VERSION "${amd_comgr_VERSION}"
  COMPATIBILITY SameMajorVersion)

if(ENABLE_ASAN_PACKAGING)
  install(TARGETS amd_comgr
    EXPORT amd_comgr_export
    COMPONENT asan
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
else()
  install(TARGETS amd_comgr
    EXPORT amd_comgr_export
    COMPONENT amd-comgr
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/include/amd_comgr.h"
  COMPONENT amd-comgr
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${amd_comgr_NAME})

#File reorg Backward compatibility function
if(FILE_REORG_BACKWARD_COMPATIBILITY)
# To enable/disable #error in wrapper header files

=== amd/hipcc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

project(hipcc VERSION "1.1.1" LANGUAGES C CXX)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

find_package(ROCM QUIET)
if(ROCM_FOUND)
  include(ROCMSetupVersion)
  rocm_setup_version(VERSION "${hipcc_VERSION}")
endif()

# Generate static package, when BUILD_SHARED_LIBS is set to OFF.
# Default to ON
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

set(ADDITIONAL_SHARED_LIBRARIES_TO_LINK
  libstdc++fs.so)

set(HIPCC_BIN
  hipcc)
set(HIPCC_SOURCES
  src/hipBin.cpp)

set(HIPCONFIG_BIN
  hipconfig)
set(HIPCONFIG_SOURCES
  src/hipBin.cpp)

add_executable(${HIPCC_BIN} ${HIPCC_SOURCES})
if(NOT WIN32)
  # C++17 does not require std lib linking.
  target_link_libraries(${HIPCC_BIN} ${ADDITIONAL_SHARED_LIBRARIES_TO_LINK})
endif()

add_executable(${HIPCONFIG_BIN} ${HIPCONFIG_SOURCES})
if(NOT WIN32)
  # C++17 does not require std lib linking.
  target_link_libraries(${HIPCONFIG_BIN} ${ADDITIONAL_SHARED_LIBRARIES_TO_LINK})
endif()

# Copy scripts and batch files to build directory.
file(COPY ${PROJECT_SOURCE_DIR}/bin/ DESTINATION ${PROJECT_BINARY_DIR})

# Packaging:
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_COMPONENTS_ALL AMD NVIDIA)
set(CPACK_GENERATOR "DEB;RPM;ZIP" CACHE STRING "Default packaging generators")
set(CPACK_PACKAGE_CONTACT "ROCm Compiler Support <rocm.compiler.support@amd.com>")
set(CPACK_PACKAGE_DESCRIPTION "HIP Compiler Driver")
set(CPACK_PACKAGE_NAME "${PROJECT_NAME}")
set(CPACK_PACKAGE_VENDOR "Advanced Micro Devices, Inc.")
set(CPACK_PACKAGE_VERSION_MAJOR "${hipcc_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${hipcc_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${hipcc_VERSION_PATCH}")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")

# Debian specific packaging variables.
set(CPACK_DEBIAN_ENABLE_COMPONENT_DEPENDS ON)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "rocm-core")
set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "perl (>= 5.0)")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/ROCm-Developer-Tools/HIPCC")
if(DEFINED ENV{CPACK_DEBIAN_PACKAGE_RELEASE})
  set(CPACK_DEBIAN_PACKAGE_RELEASE $ENV{CPACK_DEBIAN_PACKAGE_RELEASE})
else()
  set(CPACK_DEBIAN_PACKAGE_RELEASE "local")
endif()

# AMD specific Debian packaging varibles.
set(CPACK_DEBIAN_AMD_PACKAGE_NAME "hipcc")
set(CPACK_DEBIAN_AMD_PACKAGE_DEPENDS "rocm-core, rocm-llvm")
set(CPACK_DEBIAN_AMD_PACKAGE_RECOMMENDS "perl (>= 5.0)")

# NVIDIA specific Debian packaging variables.
set(CPACK_DEBIAN_NVIDIA_PACKAGE_NAME "hipcc-nvidia")
set(CPACK_DEBIAN_NVIDIA_PACKAGE_DEPENDS "rocm-core") # for NVIDIA we don't need to add rocm-llvm as a dependency
set(CPACK_DEBIAN_NVIDIA_PACKAGE_RECOMMENDS "perl (>= 5.0)") 


# RPM specific packaging variables.
set(CPACK_RPM_FILE_NAME "RPM-DEFAULT")
set(CPACK_RPM_PACKAGE_LICENSE "MIT")
set(CPACK_RPM_PACKAGE_REQUIRES "rocm-core")
set(CPACK_RPM_PACKAGE_SUGGESTS "perl >= 5.0")
set(CPACK_RPM_PACKAGE_AUTOREQPROV 0)
if(DEFINED ENV{CPACK_RPM_PACKAGE_RELEASE})
  set(CPACK_RPM_PACKAGE_RELEASE $ENV{CPACK_RPM_PACKAGE_RELEASE})
else()
  set(CPACK_RPM_PACKAGE_RELEASE "local")
endif()
if(CPACK_RPM_PACKAGE_RELEASE)
  set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)
endif()

# AMD specific RPM packaging varibables.
set(CPACK_RPM_AMD_PACKAGE_NAME "hipcc")
set(CPACK_RPM_AMD_PACKAGE_REQUIRES "rocm-core, rocm-llvm")
set(CPACK_RPM_AMD_PACKAGE_SUGGESTS "perl >= 5.0")

# NVIDIA specific RPM packaging variables.
set(CPACK_RPM_NVIDIA_PACKAGE_NAME "hipcc-nvidia")
set(CPACK_RPM_NVIDIA_PACKAGE_REQUIRES "rocm-core") # for NVIDIA we don't need to add rocm-llvm as a dependency
set(CPACK_RPM_NVIDIA_PACKAGE_SUGGESTS "perl >= 5.0")

# ROCM versioning.
set(ROCM_VERSION_FOR_PACKAGE "")
if(DEFINED ENV{ROCM_LIBPATCH_VERSION})
  set(ROCM_VERSION_FOR_PACKAGE $ENV{ROCM_LIBPATCH_VERSION})
elseif(DEFINED ENV{ROCM_VERSION})
  string(REGEX REPLACE "." "" ROCM_VERSION_FOR_PACKAGE $ENV{ROCM_VERSION})
else()
  set(ROCM_VERSION_FOR_PACKAGE "99999")
endif()
set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.${ROCM_VERSION_FOR_PACKAGE}")

# Exclude Windows specific BAT scripts from install/packaging for Linux.
if (NOT WIN32)
  # AMD specific.
  file(GLOB install_bin_files "${CMAKE_CURRENT_SOURCE_DIR}/bin/*")
  foreach(ITEM ${install_bin_files})
    # Exclude *.bat files
    if(NOT "${ITEM}" MATCHES ".bat$")
      # For *.pm files not require binary permissions
      if("${ITEM}" MATCHES ".pm$")
        LIST( APPEND gen_files "${ITEM}" )
      else()
        LIST( APPEND bin_files "${ITEM}" )
      endif()
    endif()
  endforeach()
  # Install with right type and Permissions
  install(PROGRAMS ${bin_files}
    DESTINATION ./bin
    COMPONENT AMD)
  install(FILES ${gen_files}
    DESTINATION ./bin
    COMPONENT AMD)

  # NVIDIA specific.
  install(PROGRAMS ${bin_files}
    DESTINATION ./bin
    COMPONENT NVIDIA)
  install(FILES ${gen_files}
    DESTINATION ./bin
    COMPONENT NVIDIA)
else ()
  # AMD specific.
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
    DESTINATION .
    USE_SOURCE_PERMISSIONS
    DIRECTORY_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    COMPONENT AMD)

  # NVIDIA specific.
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
    DESTINATION .
    USE_SOURCE_PERMISSIONS
    DIRECTORY_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    COMPONENT NVIDIA)
endif()

# AMD specific.
install(FILES
  "LICENSE.txt"
  "README.md"
  COMPONENT AMD
  DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(TARGETS ${HIPCC_BIN}
        COMPONENT AMD
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS ${HIPCONFIG_BIN}
        COMPONENT AMD
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# NVIDIA specific.
install(FILES
  "LICENSE.txt"
  "README.md"
  COMPONENT NVIDIA
  DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(TARGETS ${HIPCC_BIN}
        COMPONENT NVIDIA
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS ${HIPCONFIG_BIN}
        COMPONENT NVIDIA
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# TODO: WIN32 check need to be removed if backward
# compatibility is required for WIN32.
option(HIPCC_BACKWARD_COMPATIBILITY "Enable HIPCC backward compatibility" ON)
if(NOT WIN32)
  if(HIPCC_BACKWARD_COMPATIBILITY)
    include(hipcc-backward-compat.cmake)
  endif()
endif()

if(NOT ROCM_DEP_ROCMCORE)
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_DEBIAN_AMD_PACKAGE_DEPENDS ${CPACK_DEBIAN_AMD_PACKAGE_DEPENDS})
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_DEBIAN_NVIDIA_PACKAGE_DEPENDS ${CPACK_DEBIAN_NVIDIA_PACKAGE_DEPENDS})
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_RPM_PACKAGE_REQUIRES})
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_RPM_AMD_PACKAGE_REQUIRES ${CPACK_RPM_AMD_PACKAGE_REQUIRES})
  string(REGEX REPLACE ",? ?rocm-core" "" CPACK_RPM_NVIDIA_PACKAGE_REQUIRES ${CPACK_RPM_NVIDIA_PACKAGE_REQUIRES})
endif()

# Static packaging
if(NOT BUILD_SHARED_LIBS)
  # For static builds change the pakage name
  set(CPACK_DEBIAN_AMD_PACKAGE_NAME "hipcc-static-dev")
  set(CPACK_RPM_AMD_PACKAGE_NAME "hipcc-static-devel")
endif()

include(CPack)

=== amd/comgr/test-lit/CMakeLists.txt ===
function(cannonicalize_cmake_boolean var)
    if(${var})
        set(${var} 1 PARENT_SCOPE)
    else()
        set(${var} 0 PARENT_SCOPE)
    endif()
endfunction()

cannonicalize_cmake_boolean(COMGR_DISABLE_SPIRV)

configure_file(lit.site.cfg.py.in lit.site.cfg.py @ONLY)

# Comgr source build
if (EXISTS "${LLVM_TOOLS_BINARY_DIR}/../../bin/llvm-lit")
  set(LLVM_LIT_PATH "${LLVM_TOOLS_BINARY_DIR}/../../bin/llvm-lit")
# LLVM external projects build
else()
  set(LLVM_LIT_PATH "${LLVM_TOOLS_BINARY_DIR}/llvm-lit")
endif()

add_custom_target(test-lit COMMAND "${LLVM_LIT_PATH}"
                  "${CMAKE_CURRENT_BINARY_DIR}" -v)

macro(add_comgr_lit_binary name)
  add_executable("${name}" "comgr-sources/${name}.c")
  set_target_properties("${name}" PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED Yes
    C_EXTENSIONS No)
  target_link_libraries("${name}" amd_comgr)
  add_dependencies(check-comgr "${name}")
endmacro()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_comgr_lit_binary(compile-minimal-test)
add_comgr_lit_binary(source-to-bc-with-dev-libs)
add_comgr_lit_binary(spirv-translator)

add_dependencies(check-comgr test-lit)

=== amd/comgr/test/CMakeLists.txt ===
set(TEST_INPUT_BINARIES)
set(TEST_INPUT_BITCODES)
set(TEST_INPUT_BUNDLES)
set(TEST_INPUT_ARCHIVES)
set(TEST_INPUT_LINKED_OBJS)

# Create target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BINARIES target list.
macro(add_test_input_binary name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" --target=amdgcn-amd-amdhsa -mcpu=gfx900 -nogpulib
    ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}" -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BINARIES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BITCODES target list.
macro(add_test_input_bitcode name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c -emit-llvm -target amdgcn-amd-amdhsa
    -mcpu=gfx900 -nogpulib
    ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}"
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BITCODES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BUNDLES target list.
macro(add_test_input_bitcode_bundle name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c --offload-arch=gfx900 -emit-llvm -fgpu-rdc
    --gpu-bundle-output ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}"
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BUNDLES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BUNDLES target list.
macro(add_test_input_object_file_bundle name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c --offload-arch=gfx900 --gpu-bundle-output
    --offload-device-only ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}"
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BUNDLES "${name}")
endmacro()

# Creates target ${name} and output ${output} by archiving a file.
# ${target} should refer to the a target created in the above
# add_test_input_bitcode() macro, and ${input} should refer
# to the associated bitcode file built by the same macro.
macro(add_test_archive name target input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:llvm-ar>" rc "${output}" "${input}"
    VERBATIM
    DEPENDS clang lld ${target})
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_ARCHIVES "${name}")
endmacro()

# Creates target ${name} which depends on 2 clang commands to compile
# ${input0} and ${input1} and then links them to create ${output}
#  with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_LINKED_OBJS target list.
macro(add_test_input_linked name input0 input1 output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:lld>" -flavor gnu ${ARGN} "${input0}"
    "${input1}" -o "${output}"
    VERBATIM
    DEPENDS lld "${input0}" "${input1}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input0}" "${input1}")
  list(APPEND TEST_INPUT_LINKED_OBJS "${name}")
endmacro()

add_test_input_binary(reloc1 source/reloc1.cl source/reloc1.o -c -mcode-object-version=4)
add_test_input_binary(reloc2 source/reloc2.cl source/reloc2.o -c -mcode-object-version=4)
add_test_input_binary(reloc-asm source/reloc-asm.s source/reloc-asm.o -c -mcode-object-version=4)
add_test_input_binary(shared source/shared.cl source/shared.so -mcode-object-version=4)
add_test_input_binary(shared-debug source/shared.cl source/shared-debug.so -g -mcode-object-version=4)
add_test_input_bitcode(source1 source/source1.cl source/source1.bc)

add_test_input_binary(linking-kernel0 source/linking/kernel0.cl source/linking/kernel0.o -c -mcode-object-version=4)
add_test_input_binary(linking-kernel1 source/linking/kernel1.cl source/linking/kernel1.o -c -mcode-object-version=4)
add_test_input_binary(linking-empty   source/linking/empty.cl   source/linking/empty.o   -c -mcode-object-version=4)

add_test_input_linked(multiple-note-records source/linking/kernel0.o source/linking/kernel1.o source/multiple-note-records.out -w)
add_test_input_linked(multiple-note-records-one-kernel source/linking/kernel0.o source/linking/empty.o source/multiple-note-records-one-kernel.out -w)

add_test_input_bitcode_bundle(square source/square.hip source/square.bc)
add_test_input_object_file_bundle(double source/double.hip source/double.o)

add_test_input_bitcode_bundle(cube source/cube.hip source/cube.bc)
add_test_archive(cube_archive cube source/cube.bc source/cube.a)

configure_file("source/linking/kernel0.cl" "source/linking/kernel0.cl" COPYONLY)
configure_file("source/linking/kernel1.cl" "source/linking/kernel1.cl" COPYONLY)
configure_file("source/linking/empty.cl" "source/linking/empty.cl" COPYONLY)
configure_file("source/source1.cl" "source/source1.cl" COPYONLY)
configure_file("source/source2.cl" "source/source2.cl" COPYONLY)
configure_file("source/nested-kernel1.cl" "source/nested-kernel1.cl" COPYONLY)
configure_file("source/nested-kernel2.cl" "source/nested-kernel2.cl" COPYONLY)
configure_file("source/shared.cl" "source/shared.cl" COPYONLY)
configure_file("source/device_libs.cl" "source/device_libs.cl" COPYONLY)
configure_file("source/include-macro.h" "source/include-macro.h" COPYONLY)
configure_file("source/include-nested.h" "source/include-nested.h" COPYONLY)
configure_file("source/source1.s" "source/source1.s" COPYONLY)
configure_file("source/source1.hip" "source/source1.hip" COPYONLY)
configure_file("source/name-expression.hip" "source/name-expression.hip" COPYONLY)
configure_file("source/rocm56slice.b" "source/rocm56slice.b" COPYONLY)
configure_file("source/rocm57slice.b" "source/rocm57slice.b" COPYONLY)

configure_file("source/square.hip" "source/square.hip" COPYONLY)
configure_file("source/double.hip" "source/double.hip" COPYONLY)
configure_file("source/cube.hip" "source/cube.hip" COPYONLY)

# We no longer support emission of code object v2/v3. The runtime however
# can still load them so we need to test them using prebuilt binaries.
configure_file("source/legacy/shared-v2.so" "source/shared-v2.so" COPYONLY)
configure_file("source/legacy/shared12-v2.so" "source/shared12-v2.so" COPYONLY)
configure_file("source/legacy/shared14-v2.so" "source/shared14-v2.so" COPYONLY)
configure_file("source/legacy/shared23-v2.so" "source/shared23-v2.so" COPYONLY)
configure_file("source/legacy/source1-v2.o" "source/source1-v2.o" COPYONLY)
configure_file("source/legacy/source2-v2.o" "source/source2-v2.o" COPYONLY)
configure_file("source/legacy/source3-v2.o" "source/source3-v2.o" COPYONLY)
configure_file("source/legacy/source4-v2.o" "source/source4-v2.o" COPYONLY)

configure_file("source/legacy/shared-v3.so" "source/shared-v3.so" COPYONLY)
configure_file("source/legacy/shared12-v3.so" "source/shared12-v3.so" COPYONLY)
configure_file("source/legacy/shared14-v3.so" "source/shared14-v3.so" COPYONLY)
configure_file("source/legacy/shared23-v3.so" "source/shared23-v3.so" COPYONLY)
configure_file("source/legacy/source1-v3.o" "source/source1-v3.o" COPYONLY)
configure_file("source/legacy/source2-v3.o" "source/source2-v3.o" COPYONLY)
configure_file("source/legacy/source3-v3.o" "source/source3-v3.o" COPYONLY)
configure_file("source/legacy/source4-v3.o" "source/source4-v3.o" COPYONLY)

# Creates executable ${name} and accompanying test ${name} built from
# test/${name}.cl
macro(add_comgr_test name lang)
  set(test_name "comgr_${name}")
  add_executable("${name}" "${name}.${lang}")
  set_target_properties("${name}" PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED Yes
    C_EXTENSIONS No)
  target_compile_definitions("${name}"
    PRIVATE -DTEST_OBJ_DIR=\"${CMAKE_CURRENT_BINARY_DIR}/source\")
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  target_compile_definitions("${name}"
    PRIVATE -D_CRT_SECURE_NO_WARNINGS)
endif()

  target_link_libraries("${name}"
    amd_comgr)
  add_dependencies("${name}"
    ${TEST_INPUT_BINARIES};${TEST_INPUT_BITCODES};${TEST_INPUT_BUNDLES};
    ${TEST_INPUT_ARCHIVES};${TEST_INPUT_LINKED_OBJS})
  add_test(NAME ${test_name}
    COMMAND "${name}")
  add_dependencies(check-comgr ${name})
  # Windows binaries have no equivalent to RPATH, so we must set their PATH to
  # include the .lib/.dll directory.
  if (UNIX)
    set_tests_properties(${test_name}
      PROPERTIES ENVIRONMENT "AMD_COMGR_CACHE_DIR=;")
  else()
    set_tests_properties(${test_name}
      PROPERTIES ENVIRONMENT "PATH=$<TARGET_LINKER_FILE_DIR:amd_comgr>;AMD_COMGR_CACHE_DIR=;")
  endif()
endmacro()

find_package(hip CONFIG PATHS ${ROCM_INSTALL_PATH}/hip QUIET)

add_comgr_test(data_test c)
add_comgr_test(disasm_llvm_reloc_test c)
add_comgr_test(disasm_llvm_so_test c)
add_comgr_test(disasm_instr_test c)
add_comgr_test(disasm_options_test c)
add_comgr_test(metadata_tp_test c)
add_comgr_test(metadata_yaml_test c)
add_comgr_test(metadata_msgpack_test c)
add_comgr_test(metadata_multiple_msgpacks_test c)
add_comgr_test(metadata_merge_test c)
add_comgr_test(symbols_test c)
add_comgr_test(symbols_iterate_test c)
add_comgr_test(compile_test c)
add_comgr_test(compile_minimal_test c)
add_comgr_test(compile_log_test c)
add_comgr_test(compile_log_remarks_test c)
add_comgr_test(compile_source_with_device_libs_to_bc_test c)
add_comgr_test(assemble_test c)
add_comgr_test(link_test c)
add_comgr_test(isa_name_parsing_test c)
add_comgr_test(get_data_isa_name_test c)
add_comgr_test(include_subdirectory_test c)
add_comgr_test(options_test c)
add_comgr_test(demangle_test c)
add_comgr_test(fail_to_build_driver c)
add_comgr_test(file_map c)
add_comgr_test(lookup_code_object_test c)
add_comgr_test(symbolize_test c)
add_comgr_test(mangled_names_test c)
add_comgr_test(multithread_test cpp)
add_comgr_test(nested_kernel_test c)
add_comgr_test(map_elf_virtual_address_test c)
add_comgr_test(compile_source_to_executable c)
add_comgr_test(name_expression_map_test c)
add_comgr_test(compile_hip_test c)
add_comgr_test(compile_hip_to_relocatable c)
add_comgr_test(mangled_names_hip_test c)
add_comgr_test(unbundle_hip_test c)

=== amd/device-libs/test/compile/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

if(TARGET FileCheck)
  set(FILECHECK_BIN $<TARGET_FILE:FileCheck>)
else()
  # FIXME: Is there a better way to get the binary directory?
  # FileCheck is also not normally installed, so it only really works
  # well with build directories by default.
  find_program(FILECHECK_BIN FileCheck
    HINTS ${LLVM_DIR}/../../../bin)
endif()

if(NOT FILECHECK_BIN)
  message(STATUS "FileCheck not found, not adding constant fold tests")
  return()
endif()

message(STATUS "Running constant fold tests")

function(add_compile_test test_name func_name)
  set(parse_options)
  set(one_value_args TEST_CPU FILE_NAME SCRIPT EXTRA_CHECK_PREFIXES)
  set(multi_value_args COMPILE_FLAGS)

  cmake_parse_arguments(COMPILE_TEST "${parse_options}" "${one_value_args}"
    "${multi_value_args}" ${ARGN})

  set(test_cpu ${COMPILE_TEST_TEST_CPU})
  set(file_name ${COMPILE_TEST_FILE_NAME})

  add_test(NAME ${test_name}__${test_cpu}
    COMMAND ${CMAKE_COMMAND}
     -DCLANG_BIN=$<TARGET_FILE:clang>
     -DBINARY_DIR=${PROJECT_BINARY_DIR}
     -DFILECHECK_BIN=${FILECHECK_BIN}
     -DOUTPUT_FILE=output.${test_name}.${test_cpu}.s
     -DINPUT_FILE=${file_name}
     -DTEST_CPU=${test_cpu}
     -DCOMPILE_FLAGS=${COMPILE_TEST_COMPILE_FLAGS}
     -DEXTRA_CHECK_PREFIX=${COMPILE_TEST_EXTRA_CHECK_PREFIXES}
     -P ${COMPILE_TEST_SCRIPT})
endfunction()


# Add constant folding tests
function(add_constant_fold_test name test_cpu)
  add_compile_test(constant_fold_${name} ${name}
    FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/${name}.cl
    SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/RunConstantFoldTest.cmake
    TEST_CPU ${test_cpu}
    EXTRA_CHECK_PREFIXES CHECK
    ${ARGN})
endfunction()

# Add full to ISA compile tests
function(add_isa_test name test_cpu)
  string(TOUPPER ${test_cpu} check_prefix)
  add_compile_test(compile_${name} ${name}
    FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/${name}.cl
    SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/RunCompileTest.cmake
    TEST_CPU ${test_cpu}
    EXTRA_CHECK_PREFIXES "${check_prefix},GCN"
    ${ARGN})
endfunction()


foreach(gpu gfx900 gfx1030)
  add_constant_fold_test(lgamma_r ${gpu})
endforeach()

foreach(gpu gfx803)
  add_isa_test(asin ${gpu})
  add_isa_test(atan2 ${gpu})
  add_isa_test(atan2pi ${gpu})
endforeach()

foreach(gpu gfx600)
  add_isa_test(frexp ${gpu})
endforeach()

foreach(gpu gfx900)
  # Test with default denormal enabled target
  add_isa_test(rsqrt ${gpu}
    EXTRA_CHECK_PREFIXES IEEE)
  add_isa_test(rsqrt_daz ${gpu}
    FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/rsqrt.cl
    COMPILE_FLAGS -cl-denorms-are-zero
    EXTRA_CHECK_PREFIXES DAZ)
endforeach()


foreach(gpu gfx600 gfx700 gfx803)
  add_isa_test(fract ${gpu})
  add_isa_test(native_rcp ${gpu})
  add_isa_test(native_rsqrt ${gpu})
  add_isa_test(native_log ${gpu})
  add_isa_test(native_exp ${gpu})
endforeach()

=== debian/changelog ===
rocm-llvm (6.4.3+dfsg-1~exp3) experimental; urgency=medium

  * Re-upload with rocm-llvm_6.4.3+dfsg.orig.tar.xz

 -- Cordell Bloor <cgmb@debian.org>  Fri, 15 Aug 2025 04:04:26 -0600

rocm-llvm (6.4.3+dfsg-1~exp2) experimental; urgency=medium

  * Add d/p/add-hipvars-to-perl-include-path.patch to fix use of hipvars
    in hipcc and hipconfig.

 -- Cordell Bloor <cgmb@debian.org>  Fri, 15 Aug 2025 00:54:53 -0600

rocm-llvm (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3+dfsg
    * Based on LLVM 20
    * Update Files-Excluded
  * Replace libamd-comgr2 with libamd-comgr3
  * Switch to hand-written hipcc man pages
  * Update d/watch to Version 5
  * Refresh patches
  * Drop d/p/0001-add-wf64-target-constraints-to-kernels-using-w64-ins.patch
  * Drop patch numbers
  * Add d/p/upstream-llvm-compatibility.patch to enable compatibility
    with LLVM 20
  * Add d/p/cmake-4-compat.patch to enable compatibility with CMake 4.1
  * hipcc now depends on libamdhip64-dev, rather than merely recommending it.
    This is a return to the hipcc package behaviour from Trixie.
  * Add self to uploaders

 -- Cordell Bloor <cgmb@debian.org>  Thu, 14 Aug 2025 22:32:37 -0600

=== debian/control ===
Source: rocm-llvm
Section: devel
Priority: optional
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Xuanteng Huang <xuanteng.huang@outlook.com>,
           Christian Kastner <ckk@debian.org>,
           Cordell Bloor <cgmb@debian.org>
Standards-Version: 4.7.0
Homepage: https://github.com/ROCm/llvm-project
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-llvm
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-llvm.git
Build-Depends: debhelper-compat (= 13),
               cmake,
               clang-20,
               clang-tools-20,
               dh-exec,
               libclang-20-dev,
               libclang-rt-20-dev,
               libhsa-runtime-dev (>= 6.1.2~),
               libnuma-dev,
               lld-20,
               liblld-20-dev,
               llvm-20-dev,
               libzstd-dev,
               zlib1g-dev,
               libxml2-dev,
               libfile-basedir-perl,
               chrpath,
Rules-Requires-Root: no

Package: hipcc
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends},
         ${perl:Depends},
         clang-20,
         llvm-20,
         lld-20,
         clang-tools-20,
         libclang-rt-20-dev,
         rocm-device-libs-20 (= ${binary:Version}),
         rocminfo (>= 6.1.2~),
         libamdhip64-dev,
         file,
         perl
Description: C++ Runtime API and Kernel Language for AMD and NVIDIA GPUs
 HIP (Heterogeneous Interface for Portability) is a C++ Runtime API and Kernel
 Language that allows developers to create portable applications for AMD and
 NVIDIA GPUs from single source code.
 .
 Key features include:
 .
  * HIP is very thin and has little or no performance impact over coding
    directly in CUDA mode;
  * HIP allows coding in a single-source C++ programming language including
    features such as templates, C++11 lambdas, classes, namespaces, and more;
  * HIP allows developers to use the "best" development environment and tools
    on each target platform;
  * the HIPify tools automatically convert source from CUDA to HIP;
  * developers can specialize for the platform (CUDA or AMD) to tune for
    performance or handle tricky cases.
 .
 New projects can be developed directly in the portable HIP C++ language and
 can run on either NVIDIA or AMD platforms.  Additionally, HIP provides porting
 tools which make it easy to port existing CUDA codes to the HIP layer, with no
 loss of performance as compared to the original CUDA application.  HIP is not
 intended to be a drop-in replacement for CUDA, and developers should expect to
 do some manual coding and performance tuning work to complete the port.
 .
 This package provides the compiler to compile the HIP source programs.

Package: rocm-device-libs-20
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: AMD specific device-side language runtime libraries
 Set of AMD specific device-side language runtime libraries, specifically: the
 Open Compute library controls, the Open Compute Math library, the Open Compute
 Kernel library, the OpenCL built-in library, the HIP built-in library, and the
 Heterogeneous Compute built-in library.

Package: libamd-comgr3
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: ROCm code object manager
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr/amd_comgr.h .

Package: libamd-comgr-dev
Architecture: any
Section: libdevel
Depends: libamd-comgr3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ROCm code object manager - development package
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr/amd_comgr.h .
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz

CFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))
CXXFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))

ifneq ($(filter $(DEB_HOST_ARCH),armel mipsel powerpc),)
DEVICE_LIBS_CONFIG_FLAGS += -DCMAKE_CXX_STANDARD_LIBRARIES=-latomic
endif

%:
	dh $@

# comgr and hipcc rely on device-libs, so we have to build it first before config these 2 packages
override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --sourcedir=amd/device-libs --builddir=build.device-libs \
				-- $(DEVICE_LIBS_CONFIG_FLAGS)
	dh_auto_build --builddir=build.device-libs

	dh_auto_configure --buildsystem=cmake --sourcedir=amd/comgr --builddir=build.comgr \
				-- -DCMAKE_PREFIX_PATH="/usr/lib/llvm-20" \
				-DAMDDeviceLibs_DIR="$(CURDIR)/build.device-libs/lib/x86_64-linux-gnu/cmake/AMDDeviceLibs" \
				-DBUILD_TESTING=OFF -DCOMGR_BUILD_SHARED_LIBS=ON \
				-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF

	dh_auto_configure --buildsystem=cmake --sourcedir=amd/hipcc --builddir=build.hipcc \
				-- -DHIPCC_BACKWARD_COMPATIBILITY=ON

override_dh_auto_build:
	dh_auto_build --builddir=build.comgr
	dh_auto_build --builddir=build.hipcc

# dwz doesn't fully support DWARF-5 yet, see #1016936
override_dh_dwz:
	:

override_dh_auto_install:
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.device-libs
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.comgr
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.hipcc

override_dh_install:
	mv $(CURDIR)/build.comgr/amd_comgr-config.cmake.install $(CURDIR)/build.comgr/amd_comgr-config.cmake
	chrpath -d $(shell find . -type f -name libamd_comgr.so*)
	dh_install

execute_after_dh_perl:
	# dh_perl doesn't fix these because they are in a private location
	sed -i 's/\/usr\/bin\/env perl/\/usr\/bin\/perl/' $(CURDIR)/debian/hipcc/usr/share/hipcc/bin/*

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## rocm-llvm 7.0.1%2Bdfsg

=== amd/hipcc/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,16 @@
 set(HIPCC_BIN
   hipcc)
 set(HIPCC_SOURCES
-  src/hipBin.cpp)
+  src/hipBin.cpp
+  src/utils.cpp
+)
 
 set(HIPCONFIG_BIN
   hipconfig)
 set(HIPCONFIG_SOURCES
-  src/hipBin.cpp)
+  src/hipBin.cpp
+  src/utils.cpp
+)
 
 add_executable(${HIPCC_BIN} ${HIPCC_SOURCES})
 if(NOT WIN32)
@@ -65,7 +69,6 @@
 set(CPACK_DEB_COMPONENT_INSTALL ON)
 set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
 set(CPACK_DEBIAN_PACKAGE_DEPENDS "rocm-core")
-set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "perl (>= 5.0)")
 set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/ROCm-Developer-Tools/HIPCC")
 if(DEFINED ENV{CPACK_DEBIAN_PACKAGE_RELEASE})
   set(CPACK_DEBIAN_PACKAGE_RELEASE $ENV{CPACK_DEBIAN_PACKAGE_RELEASE})
@@ -76,19 +79,16 @@
 # AMD specific Debian packaging varibles.
 set(CPACK_DEBIAN_AMD_PACKAGE_NAME "hipcc")
 set(CPACK_DEBIAN_AMD_PACKAGE_DEPENDS "rocm-core, rocm-llvm")
-set(CPACK_DEBIAN_AMD_PACKAGE_RECOMMENDS "perl (>= 5.0)")
 
 # NVIDIA specific Debian packaging variables.
 set(CPACK_DEBIAN_NVIDIA_PACKAGE_NAME "hipcc-nvidia")
 set(CPACK_DEBIAN_NVIDIA_PACKAGE_DEPENDS "rocm-core") # for NVIDIA we don't need to add rocm-llvm as a dependency
-set(CPACK_DEBIAN_NVIDIA_PACKAGE_RECOMMENDS "perl (>= 5.0)") 
 
 
 # RPM specific packaging variables.
 set(CPACK_RPM_FILE_NAME "RPM-DEFAULT")
 set(CPACK_RPM_PACKAGE_LICENSE "MIT")
 set(CPACK_RPM_PACKAGE_REQUIRES "rocm-core")
-set(CPACK_RPM_PACKAGE_SUGGESTS "perl >= 5.0")
 set(CPACK_RPM_PACKAGE_AUTOREQPROV 0)
 if(DEFINED ENV{CPACK_RPM_PACKAGE_RELEASE})
   set(CPACK_RPM_PACKAGE_RELEASE $ENV{CPACK_RPM_PACKAGE_RELEASE})
@@ -102,12 +102,10 @@
 # AMD specific RPM packaging varibables.
 set(CPACK_RPM_AMD_PACKAGE_NAME "hipcc")
 set(CPACK_RPM_AMD_PACKAGE_REQUIRES "rocm-core, rocm-llvm")
-set(CPACK_RPM_AMD_PACKAGE_SUGGESTS "perl >= 5.0")
 
 # NVIDIA specific RPM packaging variables.
 set(CPACK_RPM_NVIDIA_PACKAGE_NAME "hipcc-nvidia")
 set(CPACK_RPM_NVIDIA_PACKAGE_REQUIRES "rocm-core") # for NVIDIA we don't need to add rocm-llvm as a dependency
-set(CPACK_RPM_NVIDIA_PACKAGE_SUGGESTS "perl >= 5.0")
 
 # ROCM versioning.
 set(ROCM_VERSION_FOR_PACKAGE "")

=== amd/device-libs/cuda2gcn/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB cl_sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
)

file(GLOB sources ${cl_sources})

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ocml/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ockl/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
opencl_bc_lib(NAME cuda2gcn
              SOURCES ${sources})
